import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import javax.swing.JOptionPane;

/**
 * Write a description of class Binary here.
 * 
 * @author Nichodon 
 * @version 0.2.1
 */
public class Binary extends World
{
    private Button b0;
    private Button b1;
    private Button b2;
    private Button b3;
    
    /**
     * Constructor for objects of class Binary.
     * 
     */
    public Binary()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(550, 380, 1); 
        b0 = new Button(0);
        b1 = new Button(1);
        b2 = new Button(2);
        addObject(b0, 100, 150);
        addObject(b1, 250, 150);
        addObject(b2, 400, 150);
        b3 = new Button(3);
        addObject(b3, 400, 300);
    }

    public int decimalToBinary(int number)
    {
        int answer = 0;
        if (number > 255) {
            return 0;
        }
        else {
            int counter = 128;
            int bigBin = 10000000;
            while (counter >= 1) {
                if (number >= counter) {
                    number -= counter;
                    answer += bigBin;
                }
                counter /= 2;
                bigBin /= 10;
            }
            return answer;
        }
    }

    public void print256Binaries()
    {
        String bins = "";
        for (int counter = 0; counter < 256; counter++) {
            if (counter % 8 == 0)bins = bins + (decimalToBinary(counter) + "\n");
            else bins = bins + (decimalToBinary(counter) + "         ");
        }
        JOptionPane.showMessageDialog(null, bins);
    }

    public int binaryToDecimal(int number){
        int answer = 0;
        if (number > 11111111) {
            return 0;
        }
        else {
            int bigDec = 128;
            int counter = 10000000;
            while (counter >= 1) {
                if (number >= counter) {
                    number -= counter;
                    answer += bigDec;
                }
                counter /= 10;
                bigDec /= 2;
            }
            return answer;
        }
    }
    
    public void explain()
    {
        setBackground("Explanation.png");
        b0.hide();
        b1.hide();
        b2.hide();
        b3.hide();
    }
    
    public void reset()
    {
        setBackground("Blank.png");
        b0.show();
        b1.show();
        b2.show();
        b3.show();
    }
}
