import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import javax.swing.JOptionPane;

/**
 * Write a description of class Button here.
 * 
 * @author Nichodon 
 * @version 0.2.1
 */
public class Button extends Actor
{
    private int type;
    private boolean hid;

    /**
     * Act - do whatever the Button wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        Binary bworld = (Binary)getWorld();
        if (!hid) {
            if (Greenfoot.mouseClicked(this) && type == 0) {
                JOptionPane.showMessageDialog(null, bworld.decimalToBinary(
                        Integer.parseInt(JOptionPane.showInputDialog("Your number:"))));
            }
            else if (Greenfoot.mouseClicked(this) && type == 1) {
                JOptionPane.showMessageDialog(null, bworld.binaryToDecimal(
                        Integer.parseInt(JOptionPane.showInputDialog("Your number:"))));
            }
            else if (Greenfoot.mouseClicked(this) && type == 2) {
                bworld.print256Binaries();
            }
            else if (Greenfoot.mouseClicked(this) && type == 3) {
                bworld.explain();
            }
        }
        if (Greenfoot.isKeyDown("x")) {
            bworld.reset();
        }
    }    

    public Button(int myType)
    {
        type = myType;
        if (myType == 0) {
            setImage("DTB.png");
        }
        else if (myType == 1) {
            setImage("BTD.png");
        }
        else if (myType == 2) {
            setImage("PBN.png");
        }
        else if (myType == 3) {
            setImage("WIB.png");
        }
    }

    public void hide()
    {
        GreenfootImage img = getImage();
        img.setTransparency(0);
        setImage(img);
        hid = true;
    }

    public void show()
    {
        if (type == 0) {
            setImage("DTB.png");
        }
        else if (type == 1) {
            setImage("BTD.png");
        }
        else if (type == 2) {
            setImage("PBN.png");
        }
        else if (type == 3) {
            setImage("WIB.png");
        }
        hid = false;
    }
}  
